//*  AUTHORS
//*   Antonio Manoel Ferreria Frasson <frasson@ele.ufes.br> and
//            Públio Netto de Almeida <publionetto@yahoo.com.br>.
//            Copyright (c) 2004 by Bruno Pincon,
//	      Universidade Federal do Espírito Santo.
//            All Rights Reserved. 

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "stack-c.h"
#include "umfpack.h"
#include <mex.h> 
// ATENÇÃO!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//O ERRO DO Rx ESTÁ NO ve!!!!!!!
/////////////////////////////////////////////
//  usar [val,vet]=eigen(nev,whitch,modo,OP,sigma,K);
//
//  - nev= numero de autovalores ( nev <= ordem-5 )
//  - whitch= `LM` (largest magnitude),  `SM` (smallest magnitude)
//            `LR` (largest real part),  `SR` (smallest real part) 
//            `LI` (largest imaginary),  `SI` (smallest imaginary)   
//           *`LA` (largest algebraic), *`SA` (smallest algebraic) 
//           *`BE` (half from each end) *= so para real simetrico
//  - modo=  2 caracteres: uma letra e um numero?
//           Z= problemas complexos - numero 1 a 5 modo=`Z1`,`Z2`,...
//           R= real nao simetrico  - numero 1 a 7 modo=`R1`,`R2`,... 
//           S= real simetrico      - numero 1 a 6 modo=`S1`,`S2`,...
//    Em todos os modos, a matriz a ser invertida deve ser passada em OP,
//    com excecao dos modos 1 e 2 (Z1,R2,S1,S2,..), onde nao ha inversao e
//    a matriz K=B=M eh identidade, podendo eigen ser chamado da seguinte
//    forma: [val,vet]=eigen(nev,whitch,modo,OP,sigma); com OP=A.
//    De Z1 a Z4 implementam os modos do manual do arpack, para matrizes
//    complexas e Z5 resolve no modo 2 porem multiplicando pela matriz
//    inversa de M, transformando o problema em:
//          M`.A.x=sigma.M`.M.x ,com M`=inv(M).
//    R1 a R6, implementam os modos 1 a 6 do arpack, para matrizes reais
//    nao simetricas e R7 a mesma transformacao de Z5. S1 a S5 implementam
//    os modos 1 a 5 do arpack para matrizes reais e simetricas e S6, a
//    mesma transformacao que Z5 e R7.
//  - OP= matriz a ser invertida em cada modo, com excecao dos modos 1 e 2,
//        onde K pode ser omitida na chamada de eigen por ser Identidade. 
//  - sigma= chute inicial para o autovalor, deve sempre ser complexo, 
//           que em alguns modos somente a parte real seja utilizada. 
//  - K= segunda matriz do problema. Pode ser omitida quando for identidade.
//
//
//  -- Modos 1 e 2: OP=A; K=omitida ou qualquer matriz.
//  -- Modo 3: OP=M;  K=A; 
//  -- Modo 4, 5, 6 e R7: OP=A-sigma.M; K=M;
// 
//  OBS: isso eh so uma breve explicacao, o help final sera mais detalhado. 
//

void multf(int*,int*,double*,double*,double*,double*,int,int);
void multfr(int*,int*,double*,double*,double*,int);
typedef struct {
  int m;          /* number of rows */
  int n;          /* number of columns */
  int nel;        /* number of non nuls elements */
  int it;         /* flag type : it=-1 (boolean) it=0 (real) it=1 (complex) */
  int *p;         /* n+1 array : ptr_col[n] must be equal to nel */
  int *irow;   
  double *R;
  double *I;
} CcsSparse;
static int sci_sparse_to_ccs_sparse(int num, SciSparse *A, CcsSparse *B)
{
  int taille, one=1, nel = A->nel, m = A->m, n = A->n, it = A->it;
  int l0, l1, l2, k, kb, i, j, count;

  taille = ((2*it+3)*nel + n+1 )/2 + 2;

  CreateVar(num, "d", &taille, &one, &l0);  /* return 0 in case of failure (not enough memory in stk) */

  B->m = m; B->n = n; B->nel = nel; B->it = it;
  B->R = stk(l0);
  if ( it == 1 )
    {
      B->I = stk(l0 + nel); l1 = l0 + 2*nel;
    }
  else
    {
      B->I = NULL; l1 = l0 + nel;
    }
  B->p = (int *) stk(l1); l2 = l1 + (n+1)/2 + 1;
  B->irow = (int *) stk(l2);

  for ( i = 0 ; i <= n ; i++ )
    B->p[i] = 0;

  for ( k = 0 ; k < nel ; k++ )
    B->p[A->icol[k]]++;   /* this is because  A->icol[k] is 1-based (and not 0-based) */

  for ( i = 2 ; i <= n ; i++ )
    B->p[i] += B->p[i-1];

  k = 0;
  for ( i = 0 ; i < m ; i++ )
    for ( count = 0 ; count < A->mnel[i] ; count++ )
      {
	j = A->icol[k]-1;
	kb = B->p[j];  /* "pointeur" actuel sur la colonne j */
	B->irow[kb] = i;
	B->R[kb] = A->R[k];
	if (it == 1) B->I[kb] = A->I[k];
	B->p[j]++;
	k++;
      }

  for ( i = n-1 ; i > 0 ; i-- )
    B->p[i] = B->p[i-1];
  B->p[0] = 0;

  return 1;
}

#define SciSparseToCcsSparse(num, A, B) if (! sci_sparse_to_ccs_sparse(num, A, B)) { return 0;}

int intseigen(fname)
   char *fname;
{

//#autovalores, Which, Modo,#OP,#Sigma, #B

  int its,mSigmaTemp,nSigmaTemp, SigmaTempR,SigmaTempI,mB,nB,mOP,nOP;
  int mNAutov,nNAutov,NAutov,Autovetores,Autovalores;

  int mWhich,nWhich,VWhich,mModo,nModo,VModo;

  int ncv,n,nev,neva,ldv,numd,numv;
  char *Modo,TemB,*which; // TemB eh boolean e indica se a matriz B existe (1) ou nao (0).
  double  *sigma; //[2]; // complexo

  SciSparse BB,OPP;
  CcsSparse B,OP;
// double *Control = (double *) NULL, *Info = (double *) NULL;
  CheckRhs(4,6);
  CheckLhs(1,2);

// checking variable Numero de Autovalores 
  GetRhsVar(1,"i",&mNAutov,&nNAutov,&NAutov);
  nev=*istk(NAutov); // numero de autovalores
// checking variable Modo 
  GetRhsVar(2,"c",&mModo,&nModo,&VModo);


// checking variable Which 
  GetRhsVar(3,"c",&mWhich,&nWhich,&VWhich);
  which=cstk(VWhich);
  
  if(mWhich!=2||nWhich!=1){
                           printf("which must be a string whith 2 letters!\n");
			   return 0;
			   }; 
   if(  toupper(which[1])!='M'&&
        toupper(which[1])!='R'&&
        toupper(which[1])!='I'&&
        toupper(which[1])!='A'&&
        toupper(which[1])!='E'   ) {
                 printf(" \n The second letter of variable which must be M,R,I,A or E \n");
                return 0;
      } 
   if(  toupper(which[0])!='L'&&
        toupper(which[0])!='S'&&
        toupper(which[0])!='B'   ) {
                  printf(" \n The first letter of variable which must be L,S or B, not");
		  putchar(which[0]);printf("!!!!!!");
                  return 0;
      }  
   Modo=cstk(VModo);
   Modo[0]=toupper( Modo[0]); Modo[1]=toupper( Modo[1]);//Putting all modes in upper case.
   if(Modo[0]== 'L' || Modo[0]== 'B'  || 
     (Modo[0]== 'S' && Modo[1]== 'A') || 
     (Modo[0]== 'S' && Modo[1]== 'M') || 
     (Modo[0]== 'S' && Modo[1]== 'R') || 
     (Modo[0]== 'S' && Modo[1]== 'I') ){
        printf("Maybe you put the which in the place of mode \n");
        return 0;
      };  
   if(Modo[1]>'7' || Modo[1]<'1'  )
       {
        printf("You put a wrong mode number! \n");
        return 0;
       }; 

// checking variable OP 
  GetRhsVar(4,"s",&mOP,&nOP,&OPP);
  CheckSquare(4,mOP,nOP);
               if((mOP==1)& (nOP==1))             
                {
                  printf("The argument 4 must be a matrix \n");
                  return 0;
                }
 
//     printf("passei por aqui 1");

  if((Modo[0]=='Z' && Modo[1]>'5') || (Modo[0]=='R' && Modo[1]>'7') || (Modo[0]=='S' && Modo[1]>'6'))
  {
      printf(" Invalid Mode.\n The valid modes are: Z1...Z5, R1...R7, S1...S6\n");
      return 0;
  }

     sigma=malloc(2*sizeof(double));  
  TemB=0; // parte do principio que B nao existe
  if(Rhs==4) //pode ser somente caso 1 ou 2
  {
     if(Modo[1]!='1')
     {
	if(Modo[1]==3)
	{
        printf("Error!, the number of arguments is not valid!");
	printf("For the Z3, R3 or S3 mode, the number of arguments is at least 5!");
	}
	else
	{
	printf("Error!, the number of arguments is not valid!");
        printf("For mode Z4...Z5, R4...R7 or S4...S6, the number of arguments must be 6.\n");
	}
	return 0;
     }	    
     numd=5;
     numv=6;
//   printf("passei por aqui 2");

  }    
  else if(Rhs==5)//pode ser caso 3 , 2  ou 1 sendo que o caso 3, o quinto argumento deve ser Matriz
  {
     if(Modo[1]=='1' || Modo[1]=='2')
     {
        GetRhsCVar(5,"d",&its,&mSigmaTemp,&nSigmaTemp,&SigmaTempR,&SigmaTempI);
        CheckScalar(5,mSigmaTemp,nSigmaTemp);	
         *sigma    =*stk(SigmaTempR);
        if(its==1){
         *(sigma+1)=*stk(SigmaTempI);}
        else{
         *(sigma+1)=0.0;}
     numd=6;
     numv=7;	 
     }
     else if(Modo[1]=='3')
     {
        GetRhsVar(5,"s",&mB,&nB,&BB);
        CheckSquare(5,mB,nB);
	CheckDimProp(4,5,mOP != mB);
	TemB=1; // B existe
	
     	numd=6;     
     	numv=7;
     }
     else 
     {
        printf("Error!, the number of arguments is not valid!");
        printf("For mode Z4...Z5, R4...R7 or S4...S6, the number of arguments must be 6.\n");
	return 0; 
     }
  }    
  else if(Rhs==6)    
  {//	  printf("Estou aqui, no if dos 6 argumentos-0\n");
        GetRhsCVar(5,"d",&its,&mSigmaTemp,&nSigmaTemp,&SigmaTempR,&SigmaTempI);
//	  printf("Estou aqui, no if dos 6 argumentos-1\n");
        CheckScalar(5,mSigmaTemp,nSigmaTemp);	  
         *sigma    =*stk(SigmaTempR);
        if(its==1){
         *(sigma+1)=*stk(SigmaTempI);}
        else{
         *(sigma+1)=0.0;}
     GetRhsVar(6,"s",&mB,&nB,&BB);
     //  printf("Estou aqui, no if dos 6 argumentos - 2\n");
     CheckSquare(6,mB,nB);
     CheckDimProp(4,6,mOP != mB);
     //pode ser qualquer outro caso
//     sigma=(double*)zstk(SigmaTemp);
     TemB=1;
     numd=7;
     numv=8;
  }    
  else
  {
     printf("Wrong number of arguments.\n");
     return 0;
  }
    SciSparseToCcsSparse(numd, &OPP, &OP);
//    printf("passei por aqui 3");
    if(Rhs==6 || (Rhs==5 && Modo[1]=='3') ){
	    SciSparseToCcsSparse(numv, &BB, &B);
	    numd=numd+2;numv=numv+2;       }
    else { numd=numd+1;numv=numv+1;}
       
/**************************************************************************/
/******************     DECLARACOES E INICIALIZACOES     ******************/
/**************************************************************************/


/***   CONSTANTES   ***/

// n   = ordem da matriz ;
// nev = numero de autovalores ;
// ncv = numero de autovetores
// ldv = comprimento do vetor v - igual a n

  n=mOP;             // ordem da matriz

  ncv=nev+2;         // numero de autovetores
  ldv=n;             // ldv = comprimento do vetor v - igual a n

  neva=1;
/***** Variaveis e Vetores de tamanho fixo *****/

   int     iparam[11], ipntr[14];
   int     flag;
   char    bmat;// [2]={'L','M'};
   int     ido,lworkl,info,ierr,nconv,maxitr,ishfts,mode;
   double  tol;
   int     rvec,i,j,k;
 
   tol    = 0.0000001;
   ido    = 0;
   info   = 0;

   ishfts = 1;
   maxitr = 50000;
//   mode   = 3; //modo do _naupd

   iparam[0] = ishfts;
   iparam[1] = 0;
   iparam[2] = maxitr;
   iparam[3] = 1;
   iparam[4] = 0;
   iparam[5] = 0;
// iparam[6] = mode;
   iparam[7] = 0;
   iparam[8] = 0;
   iparam[9] = 0;
   iparam[10] = 0;


/*** Vetores de tamanho variavel ***/
/*** INTEIRO ***/
   int  *ipiv, *select; // select e boolean

   ipiv  = (int*)malloc(  n*sizeof(int));
   select= (int*)malloc(ncv*sizeof(int));

/*** COMPLEXO  ou  REAL ***/
   double *d, *dz , *v,*vector, *workd , *resid, *workev, *workl;
 
   /***** Variaveis do UMFPACK   *******/
   double Info [UMFPACK_INFO], Control [UMFPACK_CONTROL];

   void   *Symbolic, *Numeric;
 
   double *Wz;
   int    *Wi, status;
   int contador;


/***********************************/

   // Matriz A=OP e M=B;
   int *Ap,*Ai,*Mp,*Mi,opisreal,misreal;
   double *Ar,*Az,*Mr,*Mz,*br,*bz,*xr,*xz;

   opisreal=(OP.it==0);
   Ar=OP.R;
   if(!opisreal) Az= OP.I;
   Ai=OP.irow;
   Ap=OP.p;
   if(TemB/*Rhs==6*/) // Se a matriz B existe, linka ela com a matriz B interna (variaveis Mr, Mz, Mp).
   {
      misreal=(B.it==0);
      Mr=B.R;
      if(!misreal) Mz= B.I;
      Mi=B.irow;
      Mp=B.p;

   }
   else
   {
      misreal=0;
   }
  

   v = (double*)malloc((2*ldv*(ncv+1))*sizeof(double));
   vector=(double*)malloc((2*ldv*(ncv+1))*sizeof(double));


////////////////////////////////////////////////////////////////////////////////////////////////////
//                COMPLEX
////////////////////////////////////////////////////////////////////////////////////////////////////
 
if(toupper(Modo[0])=='Z')
{ 
   d      = (double*)malloc( 2*ncv*sizeof(double) );

   lworkl=3*ncv*ncv+5*ncv;//complexo

   workd  = (double*)malloc( 2*3*n*sizeof(double) );
   resid  = (double*)malloc( 2*n*sizeof(double) );
   workev = (double*)malloc( 2*2*ncv*sizeof(double) );
   workl  = (double*)malloc( 2*(lworkl)*sizeof(double) );

/***  DOUBLE  ***/
   double *rwork;
   rwork=(double*)malloc( n*sizeof(double) );

   if(opisreal)
   {
      Az= (double *) malloc (OP.nel*sizeof(double));  
      for(i=0;i<OP.nel;i++) Az[i]=0.0;
   }

   if(toupper(Modo[1])!='1')
   {
      br=(double *)malloc(n*sizeof(double));
      bz=(double *)malloc(n*sizeof(double));
      xr=(double *)malloc(n*sizeof(double));
      xz=(double *)malloc(n*sizeof(double));
        
      if(misreal)
      {
          Mz= (double *) malloc (B.nel*sizeof(double));  
          for(i=0;i<B.nel;i++) Mz[i]=0.0;
      }
         
      Wz = (double *) malloc (10*n*sizeof(double));
      Wi = (int *) malloc (n*sizeof(int));

/*******      UMFPACK         *******/
         if(opisreal)
        {
              umfpack_di_defaults(Control) ;
              status=umfpack_di_symbolic(n,n,Ap,Ai,Ar,&Symbolic,Control,Info);
              status=umfpack_di_numeric(Ap,Ai,Ar,Symbolic,&Numeric,Control,Info);
              umfpack_di_free_symbolic(&Symbolic);
        }  
	else
	{
	      umfpack_di_defaults(Control) ;
              status=umfpack_zi_symbolic(n,n,Ap,Ai,Ar,Az,&Symbolic,Control,Info);
              status=umfpack_zi_numeric(Ap,Ai,Ar,Az,Symbolic,&Numeric,Control,Info);
              umfpack_zi_free_symbolic(&Symbolic);
	}
/************************************/
   }

   switch ( toupper(Modo[1]) ) {
   case '1': //A.x=lambda.x - modo regular sem inversao
     mode = 1;
     iparam[6] = mode;
     bmat='I';
     contador=0;
     flag=1;
     while(flag)
     {
        flag=0;
        znaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,rwork,&info);

        if(ido==-1 || ido==1 )
        {
           multf(Ap,Ai,Ar,Az,workd+2*(ipntr[0]-1), workd+2*(ipntr[1]-1),n,1);
           flag=1;
	   	   contador = contador + 1;
//	   printf("passei %d \n",contador);

        }
     }
     break;

   case '2': //A.x=sigma.x - shift invert mode
     mode = 3;
     iparam[6] = mode;
     bmat='I';

     flag=1;
     while(flag)
     {
        flag=0;
        znaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,rwork,&info);  
        if(ido==-1 || ido==1 )
        {
/** Acrescentado por causa do UMFPACK **/
           for(i=0;i<n;i++)
           {
              br[i]=*(workd+2*(ipntr[0]-1)+2*i);
              bz[i]=*(workd+2*(ipntr[0]-1)+2*i+1);
           }
	   if(opisreal){
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,xr,br,Numeric, Control,Info,Wi,Wz);
	   status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,xz,bz,Numeric, Control,Info,Wi,Wz);
	               }
           else
	               {
           status=umfpack_zi_wsolve(UMFPACK_A,Ap,Ai,Ar,Az,xr,xz,br,bz,Numeric, Control,Info,Wi,Wz);
		       }
           for(i=0;i<n;i++)
           {
              *(workd+2*(ipntr[1]-1)+2*i)=xr[i];
              *(workd+2*(ipntr[1]-1)+2*i+1)=xz[i];
           } 
/***************************************/
           if( status!=0 )
           {
	      if( opisreal)printf("\n ERRO NO UMFPACK_DI_WSOLVE 1. \n");
              if(!opisreal)printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
     }

/************** UMFPACK  ****************/
     if(opisreal)umfpack_di_free_numeric(&Numeric);
     else umfpack_zi_free_numeric(&Numeric);
/****************************************/

     break;

   case '3': //A(neste programa)=OP=M(externo)   B=A(externo)
     mode = 2;
     iparam[6] = mode;
     bmat='G';
 
     flag=1;
     while(flag)
     {
        flag=0;
        znaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,rwork,&info);  
        if(ido==-1 || ido==1 )
        {
           multf(Mp,Mi,Mr,Mz,workd+2*(ipntr[0]-1), workd+2*(ipntr[1]-1),n,1);
/** Acrescentado por causa do UMFPACK **/
           for(i=0;i<n;i++)
           {   
              br[i]=*(workd+2*(ipntr[1]-1)+2*i);
              bz[i]=*(workd+2*(ipntr[1]-1)+2*i+1);
           }
	   if(opisreal){
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,xr,br,Numeric, Control,Info,Wi,Wz);
	   status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,xz,bz,Numeric, Control,Info,Wi,Wz);
	               }
           else
	               {
           status=umfpack_zi_wsolve(UMFPACK_A,Ap,Ai,Ar,Az,xr,xz,br,bz,Numeric, Control,Info,Wi,Wz);
		       }
           for(i=0;i<n;i++)
           {
              *(workd+2*(ipntr[1]-1)+2*i)=xr[i];
              *(workd+2*(ipntr[1]-1)+2*i+1)=xz[i];
           }
/***************************************/
           if( status!=0 )
           {
	      if( opisreal)printf("\n ERRO NO UMFPACK_DI_WSOLVE 1. \n");
              if(!opisreal)printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==2 )
        {
           multf(Ap,Ai,Ar,Az,workd+2*(ipntr[0]-1), workd+2*(ipntr[1]-1),n,1);
           flag=1;
        }
     }

/************** UMFPACK  ****************/
     if(opisreal)umfpack_di_free_numeric(&Numeric);
     else umfpack_zi_free_numeric(&Numeric);
/****************************************/
     break;

   case '4': //A=OP=(A-sigma.M) B=M
     mode = 3;
     iparam[6] = mode;
     bmat='G';

     flag=1;
     while(flag)
     {
        flag=0;
        znaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,rwork,&info);  
        if(ido==-1)
        {
           multf(Mp,Mi,Mr,Mz,workd+2*(ipntr[0]-1), workd+2*(ipntr[1]-1),n,1);
/** Acrescentado por causa do UMFPACK **/
           for(i=0;i<n;i++)
           {   
              br[i]=*(workd+2*(ipntr[1]-1)+2*i);
              bz[i]=*(workd+2*(ipntr[1]-1)+2*i+1);
           }
	   if(opisreal){
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,xr,br,Numeric, Control,Info,Wi,Wz);
	   status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,xz,bz,Numeric, Control,Info,Wi,Wz);
	               }
           else
	               {
           status=umfpack_zi_wsolve(UMFPACK_A,Ap,Ai,Ar,Az,xr,xz,br,bz,Numeric, Control,Info,Wi,Wz);
		       }
           for(i=0;i<n;i++)
           {
              *(workd+2*(ipntr[1]-1)+2*i)=xr[i];
              *(workd+2*(ipntr[1]-1)+2*i+1)=xz[i];
           }
/***************************************/
           if( status!=0 )
           {
	      if( opisreal)printf("\n ERRO NO UMFPACK_DI_WSOLVE 1. \n");
              if(!opisreal)printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==1 )
        {
/** Acrescentado por causa do UMFPACK **/
           for(i=0;i<n;i++)
           {   
              br[i]=*(workd+2*(ipntr[2]-1)+2*i);
              bz[i]=*(workd+2*(ipntr[2]-1)+2*i+1);
           }
	   if(opisreal){
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,xr,br,Numeric, Control,Info,Wi,Wz);
	   status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,xz,bz,Numeric, Control,Info,Wi,Wz);
	               }
           else
	               {
           status=umfpack_zi_wsolve(UMFPACK_A,Ap,Ai,Ar,Az,xr,xz,br,bz,Numeric, Control,Info,Wi,Wz);
		       }
           for(i=0;i<n;i++)
           {
              *(workd+2*(ipntr[1]-1)+2*i)=xr[i];
              *(workd+2*(ipntr[1]-1)+2*i+1)=xz[i];
           }
/***************************************/
           if( status!=0 )
           {
	      if( opisreal)printf("\n ERRO NO UMFPACK_DI_WSOLVE 1. \n");
              if(!opisreal)printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==2 )
        {
           multf(Mp,Mi,Mr,Mz,workd+2*(ipntr[0]-1), workd+2*(ipntr[1]-1),n,1);
           flag=1;
        }
     }
/************** UMFPACK  ****************/
     if(opisreal)umfpack_di_free_numeric(&Numeric);
     else umfpack_zi_free_numeric(&Numeric);
/****************************************/
     break;

   case '5'://OP=(A-sigma.M) B=M - resolve fazendo OP= (A-sigma.M)'.M e B=I (A-sigma.M)'=inv(A-sigma.M)
     mode = 3;
     iparam[6] = mode;
     bmat='I';

     flag=1;
     while(flag)
     {
        flag=0;

        znaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,rwork,&info);  
        if(ido==-1 || ido==1 )
        {

           multf(Mp,Mi,Mr,Mz,workd+2*(ipntr[0]-1), workd+2*(ipntr[1]-1),n,1);

/** Acrescentado por causa do UMFPACK **/
           for(i=0;i<n;i++)
           {
              br[i]=*(workd+2*(ipntr[1]-1)+2*i);
              bz[i]=*(workd+2*(ipntr[1]-1)+2*i+1);
           }

	   if(opisreal){
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,xr,br,Numeric, Control,Info,Wi,Wz);
	   status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,xz,bz,Numeric, Control,Info,Wi,Wz);
	               }
           else
	               {
           status=umfpack_zi_wsolve(UMFPACK_A,Ap,Ai,Ar,Az,xr,xz,br,bz,Numeric, Control,Info,Wi,Wz);
		       }

           for(i=0;i<n;i++)
           {
              *(workd+2*(ipntr[1]-1)+2*i)=xr[i];
              *(workd+2*(ipntr[1]-1)+2*i+1)=xz[i];
           }
/***************************************/
           if( status!=0 )
           {
 	      if( opisreal)printf("\n ERRO NO UMFPACK_DI_WSOLVE 1. \n");
              if(!opisreal)printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
     }
/************** UMFPACK  ****************/
     if(opisreal)umfpack_di_free_numeric(&Numeric);
     else umfpack_zi_free_numeric(&Numeric);
/****************************************/
     break;

   default:
     printf("Modo Invalido.");
   }

   if( info<0 )
   {
      printf("\n Error with _naupd, info = %d ", info);
      printf("\n Check the documentation of _naupd.\n");
   }
   else
   {
      rvec = 1;/*TRUE*/
      zneupd_(&rvec,"A",select,d,v,&ldv,sigma,workev,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,rwork,&ierr);

      if(ierr!=0)
      {
          printf("\n Error with _neupd, info = %d", ierr );
          printf("\n Check the documentation of _neupd. \n");
      }
      if( info == 1)
          printf("\n Maximum number of iterations reached.\n");
      else if( info==3)
      {
          printf("\n No shifts could be applied during implicit ");
          printf("\n  Arnoldi update, try increasing NCV. \n");
      }
   }
   
   if(opisreal) free(Az);      
   if(toupper(Modo[1])!='1')
   {
       if(misreal) free(Mz);
       free(Wz);free(Wi);
       free(br);free(bz);
       free(xr);free(xz);
   }
// creating variable Autovalores, vetor com todos os autovalores 
  CreateVar(numd,"z",&nev,&neva,&Autovalores); // vetor d - autovalores

// creating variable Autovetores, vetor com todos os autovetores 
  CreateVar(numv,"z",&ldv ,&nev/*&ncv*/,&Autovetores); //vetor v



   for(i=0,k=0;i<nev;i++)   
   {
      for(j=0;j<ldv;j++,k+=2)   
      {

           *((double*)zstk(Autovetores)+k)=v[k];
           *((double*)zstk(Autovetores)+k+1)=v[k+1];

      }
      *((double*)zstk(Autovalores)+2*i)=d[2*i];
      *((double*)zstk(Autovalores)+2*i+1)=d[2*i+1];
   }

   free(d);
   free(rwork);
}

//////////////////////////////////////////////////////////////////////////////////////////
//
//                           REAL NAO SIMETRICO
//
/////////////////////////////////////////////////////////////////////////////////////////
else if(toupper(Modo[0])=='R') // Se eh real nao simetrico
{



   d= (double*)malloc((ncv+2)*sizeof(double)); //AUTO VALOR PARTE REAL
   dz=(double*)malloc((ncv+2)*sizeof(double)); //AUTO VALOR PARTE IMAGINARIA

   lworkl=3*ncv*ncv+6*ncv;//real

   workd  = (double*)malloc( 3*n*sizeof(double) );
   resid  = (double*)malloc( n*sizeof(double) );
   workev = (double*)malloc( 3*ncv*sizeof(double) );
   workl  = (double*)malloc( (lworkl)*sizeof(double) );
   if(toupper(Modo[1])!='1')
   {
      Wi = (int *) malloc (n*sizeof(int));
      if(opisreal)
      {
         Wz = (double *) malloc (5*n*sizeof(double));
/*******      UMFPACK         *******/
         umfpack_di_defaults(Control) ;
         status=umfpack_di_symbolic(n,n,Ap,Ai,Ar,&Symbolic,Control,Info);
         status=umfpack_di_numeric(Ap,Ai,Ar,Symbolic,&Numeric,Control,Info);  
         umfpack_di_free_symbolic(&Symbolic);
/************************************/
      }     
      else
      {
         Wz = (double *) malloc (10*n*sizeof(double));
/*******      UMFPACK         *******/
         umfpack_zi_defaults(Control) ;
         status=umfpack_zi_symbolic(n,n,Ap,Ai,Ar,Az,&Symbolic,Control,Info);
         status=umfpack_zi_numeric(Ap,Ai,Ar,Az,Symbolic,&Numeric,Control,Info);
         umfpack_zi_free_symbolic(&Symbolic);
/************************************/
      }
   }

   bz=(double *)malloc(n*sizeof(double));
contador=0;ido=0;
   switch ( toupper(Modo[1]) ) {
   case '1': //A.x=lambda.x - modo regular sem inversao
	        mode = 1;
	
     info=1;
     iparam[6] = mode;
     bmat='I';
     flag=1;
     while(flag)
     {
        flag=0;tol=0.00001;
        dnaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1 || ido==1 )
        {
	     	multfr(Ap,Ai,Ar,workd+(ipntr[0]-1), workd+(ipntr[1]-1),n);
           flag=1;
	   contador = contador + 1;
//	   printf("passei R1 = %d  \n",contador);
        }
     }
     break;

   case '2': //A.x=sigma.x - shift invert mode
     mode = 3;
     iparam[6] = mode;
     bmat='I';

     flag=1;
     while(flag)
     {
        flag=0;
        dnaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1 || ido==1 )
        {
                                                        //XR          ,    BR   
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),(workd+(ipntr[0]-1)),Numeric, Control,Info,Wi,Wz);

           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_DI_WSOLVE CASO R2. \n");
              return 0;
           }
           flag=1;
        }
     }
     break;

   case '3': //A(neste programa)=OP=M(externo)   B=A(externo)
     mode = 2;
     iparam[6] = mode;
     bmat='G';
 
     flag=1;
     while(flag)
     {
        flag=0;
        dnaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
         
        if(ido==-1 || ido==1 )
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1),bz,n);
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),bz,Numeric, Control,Info,Wi,Wz);
           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_DI_WSOLVE CASO R3. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==2 )
        {
           multfr(Ap,Ai,Ar,workd+(ipntr[0]-1), workd+(ipntr[1]-1),n);
           flag=1;
        }
     }
     break;

   case '4': //A=OP=(A-sigma.M) B=M
     mode = 3;
     iparam[6] = mode;
     bmat='G';

     flag=1;
     while(flag)
     {
        flag=0;
        dnaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1 )
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1), bz,n);
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),bz,Numeric, Control,Info,Wi,Wz);
           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==1 )
        {
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),(workd+(ipntr[2]-1)),Numeric, Control,Info,Wi,Wz);
           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_ZI_WSOLVE 2. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==2 )
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1), workd+(ipntr[1]-1),n);
           flag=1;
        }
     }
     break;

   case '5':
     xz=(double *)malloc(n*sizeof(double));
     br=(double *)malloc(n*sizeof(double));
     mode = 3;
     iparam[6] = mode;
     bmat='G';
     
     if(opisreal)
     {
         Az= (double *) malloc (OP.nel*sizeof(double));  
         for(i=0;i<OP.nel;i++) Az[i]=0.0;
     }

     for(i=0;i<n;i++) bz[i]=0;

     flag=1;
     while(flag)
     {
        flag=0;
        dnaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1)
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1), br,n);
	   if(!opisreal){
             status=umfpack_zi_wsolve(UMFPACK_A,Ap,Ai,Ar,Az,(workd+(ipntr[1]-1)),xz,br,bz,Numeric, Control,Info,Wi,Wz);}
	   else{
             status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),br,Numeric, Control,Info,Wi,Wz);
	     status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,                  xz,bz,Numeric, Control,Info,Wi,Wz);
	      }
           if( status!=0 )
           {
	      if(opisreal){
                       printf("\n ERRO NO UMFPACK_DI_WSOLVE 1. \n");}
	      else        {
	                printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");}
              return 0;
           }
           flag=1;
        }
        else if(ido==1 )
        {
 	   if(!opisreal){
             status=umfpack_zi_wsolve(UMFPACK_A,Ap,Ai,Ar,Az,(workd+(ipntr[1]-1)),xz,br,bz,Numeric, Control,Info,Wi,Wz);}
	   else{
             status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),br,Numeric, Control,Info,Wi,Wz);
	     status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,                  xz,bz,Numeric, Control,Info,Wi,Wz);
	      }
          if( status!=0 )
           {
	      if(opisreal){
                       printf("\n ERRO NO UMFPACK_DI_WSOLVE 1. \n");}
	      else{
		       printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");}
              return 0;
           }
           flag=1;
        }
        else if(ido==2 )
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1), workd+(ipntr[1]-1),n);
           flag=1;
        }
     }
     free(xz);
     free(br);
     if(opisreal)free(Az);
     break;

   case '6':
     xr=(double *)malloc(n*sizeof(double));
     br=(double *)malloc(n*sizeof(double));

     mode = 3;
     iparam[6] = mode;
     bmat='G';

     if(opisreal)
     {
         Az= (double *) malloc (OP.nel*sizeof(double));  
         for(i=0;i<OP.nel;i++) Az[i]=0.0;
     }

     for(i=0;i<n;i++) bz[i]=0;
 	   if(!opisreal){
             status=umfpack_zi_wsolve(UMFPACK_A,Ap,Ai,Ar,Az,(workd+(ipntr[1]-1)),xz,br,bz,Numeric, Control,Info,Wi,Wz);}
	   else{
             status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),br,Numeric, Control,Info,Wi,Wz);
	     status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,                  xz,bz,Numeric, Control,Info,Wi,Wz);
	      }
          if( status!=0 )
           {
	      if(opisreal){
                       printf("\n ERRO NO UMFPACK_DI_WSOLVE 1. \n");}
	      else{
		       printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");}
              return 0;
           }

     flag=1;
     while(flag)
     {
        flag=0;
        dnaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1)
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1), br,n);


	   flag=1;
        }
        else if(ido==1 )
        {
 	   if(!opisreal){
             status=umfpack_zi_wsolve(UMFPACK_A,Ap,Ai,Ar,Az,(workd+(ipntr[1]-1)),xz,br,bz,Numeric, Control,Info,Wi,Wz);}
	   else{
             status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),br,Numeric, Control,Info,Wi,Wz);
	     status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,                  xz,bz,Numeric, Control,Info,Wi,Wz);
	      }
          if( status!=0 )
           {
	      if(opisreal){
                       printf("\n ERRO NO UMFPACK_DI_WSOLVE 1. \n");}
	      else{
		       printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");}
              return 0;
           }
           flag=1;
        }
        else if(ido==2 )
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1), workd+(ipntr[1]-1),n);
           flag=1;
        }
     }
     free(xr);
     free(br);

     if(opisreal) free(Az);

     break;

   case '7':
     mode = 3;
     iparam[6] = mode;
     bmat='I';
 
     br=(double *)malloc(n*sizeof(double));

     flag=1;
     while(flag)
     {
        flag=0;

        dnaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  

        if(ido==-1 || ido==1 )
        {

           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1),br,n);
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),br,Numeric, Control,Info,Wi,Wz);

           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
     }
     free(br);
     break;

   default:
     printf("Modo Invalido.");
   }

/************** UMFPACK  ****************/
   if(toupper(Modo[1])!='1'){ 
                             if(!opisreal)
                                umfpack_zi_free_numeric(&Numeric);
                             else
                                umfpack_di_free_numeric(&Numeric);
                              };
/****************************************/
   if( info<0 )
   {
      printf("\n Error with _naupd, info = %d ", info);
      printf("\n Check the documentation of _naupd.\n");
   }
   else
   {
      rvec = 1;/*TRUE*/

      dneupd_(&rvec,"A",select,d,dz,vector,&ldv,sigma,sigma+1,workev,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&ierr);


      if(ierr!=0)
      {
          printf("\n Error with _neupd, info = %d", ierr );
          printf("\n Check the documentation of _neupd. \n");
      }
      if( info == 1)
          printf("\n Maximum number of iterations reached.\n");
      else if( info==3)
      {
          printf("\n No shifts could be applied during implicit ");
          printf("\n  Arnoldi update, try increasing NCV. \n");
      }
   }

 
// creating variable Autovalores, vetor com todos os autovalores 
  CreateVar(numd,"z",&nev,&neva,&Autovalores); // vetor d - autovalores

// creating variable Autovetores, vetor com todos os autovetores 
  CreateVar(numv,"z",&ldv ,&nev/*&ncv*/,&Autovetores); //vetor v


   k=0;
   for(i=0;i<nev;i++)   
   {
      *((double*)zstk(Autovalores)+2*i)=d[i];
      *((double*)zstk(Autovalores)+2*i+1)=dz[i];

      if(ceil(dz[i]*1e7)==0)
      {   
         for(j=0;j<ldv;j++)   
         {
           *((double*)zstk(Autovetores)+2*j+2*i*ldv)=vector[(j+k*ldv)];
           *((double*)zstk(Autovetores)+2*j+1+2*i*ldv)=0; 
         }
         k++;
      }
      else
      {
         if(i>0 && d[i]==d[i-1] && dz[i]==-dz[i-1])
         { 
            k--;
            for(j=0;j<ldv;j++)   
            {
              *((double*)zstk(Autovetores)+2*j+2*i*ldv)=vector[(j+(k-1)*ldv)];
              *((double*)zstk(Autovetores)+2*j+1+2*i*ldv)=-vector[(j+k*ldv)]; 
            }
         } 
         else 
         {
            k++;
            for(j=0;j<ldv;j++)   
            {
              *((double*)zstk(Autovetores)+2*j+2*i*ldv)=vector[(j+(k-1)*ldv)];
              *((double*)zstk(Autovetores)+2*j+1+2*i*ldv)=vector[(j+k*ldv)]; 
            }
         }
         k++;
      }

   }
 


   free(d);
   free(dz);
   free(bz);
   if(toupper(Modo[1])!='1')
   {
      free(Wi);free(Wz);
   }

}

//////////////////////////////////////////////////////////////////////////////////////////
//
//                           REAL  SIMETRICO
//
/////////////////////////////////////////////////////////////////////////////////////////

else if(toupper(Modo[0])=='S') // Se eh real e simetrico
{

//   d      = (double*)malloc( ncv*sizeof(double) );
   d= (double*)malloc(ncv*sizeof(double));

   lworkl=3*ncv*ncv+6*ncv;//real

   workd  = (double*)malloc( 3*n*sizeof(double) );
   resid  = (double*)malloc( n*sizeof(double) );
   workev = (double*)malloc( 3*ncv*sizeof(double) );
   workl  = (double*)malloc( (lworkl)*sizeof(double) );

/****************/

   if(toupper(Modo[1])!='1')
   {
      Wi = (int *) malloc (n*sizeof(int));
      Wz = (double *) malloc (5*n*sizeof(double));
/*******      UMFPACK         *******/
      umfpack_di_defaults(Control) ;
      status=umfpack_di_symbolic(n,n,Ap,Ai,Ar,&Symbolic,Control,Info);
      status=umfpack_di_numeric(Ap,Ai,Ar,Symbolic,&Numeric,Control,Info);  
      umfpack_di_free_symbolic(&Symbolic);
/************************************/
   }

   bz=(double *)malloc(n*sizeof(double));

   switch ( toupper(Modo[1]) ) {
   case '1': //A.x=lambda.x - modo regular sem inversao
     mode = 1;
     iparam[6] = mode;
     bmat='I';

     flag=1;
     while(flag)
     {
        flag=0;
        dsaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1 || ido==1 )
        {
           multfr(Ap,Ai,Ar,workd+(ipntr[0]-1), workd+(ipntr[1]-1),n);
           flag=1;
        }
     }

     break;

   case '2': //A.x=sigma.x - shift invert mode
     mode = 3;
     iparam[6] = mode;
     bmat='I';

     flag=1;
     while(flag)
     {
        flag=0;
        dsaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1 || ido==1 )
        {
                                                        //XR          ,    BR   
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),(workd+(ipntr[0]-1)),Numeric, Control,Info,Wi,Wz);

           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
     }
/************** UMFPACK  ****************/
/****************************************/
     umfpack_di_free_numeric(&Numeric);
/****************************************/
/****************************************/

     break;

   case '3': //A(neste programa)=OP=M(externo)   B=A(externo)
     mode = 2;
     iparam[6] = mode;
     bmat='G';
 
     flag=1;
     while(flag)
     {
        flag=0;
        dsaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1 || ido==1 )
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1),workd+(ipntr[0]-1),n);

           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),(workd+(ipntr[0]-1)),Numeric, Control,Info,Wi,Wz);

           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==2 )
        {
           multfr(Ap,Ai,Ar,workd+(ipntr[0]-1), workd+(ipntr[1]-1),n);
           flag=1;
        }
     }
/************** UMFPACK  ****************/
     umfpack_di_free_numeric(&Numeric);
/****************************************/
     break;

   case '4': //A=OP=(A-sigma.M) B=M
     mode = 3;
     iparam[6] = mode;
     bmat='G';

     flag=1;
     while(flag)
     {
        flag=0;
        dsaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1 )
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1), bz,n);

           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),bz,Numeric, Control,Info,Wi,Wz);

           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==1 )
        {
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),(workd+(ipntr[2]-1)),Numeric, Control,Info,Wi,Wz);
           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_ZI_WSOLVE 2. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==2 )
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1), workd+(ipntr[1]-1),n);
           flag=1;
        }
     }
/************** UMFPACK  ****************/
     umfpack_di_free_numeric(&Numeric);
/****************************************/
     break;

   case '5':
     br=(double *)malloc(n*sizeof(double));
     mode = 4;
     iparam[6] = mode;
     bmat='G';
     
     for(i=0;i<n;i++) bz[i]=0;

     flag=1;
     while(flag)
     {
        flag=0;
        dsaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1)
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1), br,n);
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),br,Numeric, Control,Info,Wi,Wz);
           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_ZI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==1 )
        {
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),(workd+(ipntr[2]-1)),Numeric, Control,Info,Wi,Wz);
           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_ZI_WSOLVE 2. \n");
              return 0;
           }
           flag=1;
        }
        else if(ido==2 )
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1), workd+(ipntr[1]-1),n);
           flag=1;
        }
     }
     free(br);
/************** UMFPACK  ****************/
     umfpack_di_free_numeric(&Numeric);
/****************************************/
     break;

   case '6'://OP=(A-sigma.M) B=M - resolve fazendo OP= M'.(A-sigma.M) e B=I M'=inv(M)
     mode = 3;
     iparam[6] = mode;
     bmat='I';
 
     br=(double *)malloc(n*sizeof(double));

     flag=1;
     while(flag)
     {
        flag=0;
        dsaupd_(&ido,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info);  
        if(ido==-1 || ido==1 )
        {
           multfr(Mp,Mi,Mr,workd+(ipntr[0]-1),br,n);
           status=umfpack_di_wsolve(UMFPACK_A,Ap,Ai,Ar,(workd+(ipntr[1]-1)),br,Numeric, Control,Info,Wi,Wz);
           if( status!=0 )
           {
              printf("\n ERRO NO UMFPACK_DI_WSOLVE 1. \n");
              return 0;
           }
           flag=1;
        }
     }
     free(br);
/************** UMFPACK  ****************/
     umfpack_di_free_numeric(&Numeric);
/****************************************/
     break;

   default:
     printf("Modo Invalido.");
   }
   
   if( info<0 )
   {
      printf("\n Error with _naupd, info = %d ", info);
      printf("\n Check the documentation of _naupd.\n");
   }
   else
   {
      rvec = 1;/*TRUE*/
      dseupd_(&rvec,"A",select,d,v,&ldv,sigma,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&ierr);
      if(ierr!=0)
      {
          printf("\n Error with _neupd, info = %d", ierr );
          printf("\n Check the documentation of _neupd. \n");
      }
      if( info == 1)
          printf("\n Maximum number of iterations reached.\n");
      else if( info==3)
      {
          printf("\n No shifts could be applied during implicit ");
          printf("\n  Arnoldi update, try increasing NCV. \n");
      }
   }
// creating variable Autovalores, vetor com todos os autovalores 
  CreateVar(numd,"z",&nev,&neva,&Autovalores); // vetor d - autovalores

// creating variable Autovetores, vetor com todos os autovetores 
  CreateVar(numv,"z",&ldv ,&nev/*&ncv*/,&Autovetores); //vetor v


   for(i=0;i<nev;i++)   
   {
      for(j=0;j<ldv;j++)   
      {
        *((double*)zstk(Autovetores)+2*j+2*i*ldv)=v[(j+i*ldv)];
        *((double*)zstk(Autovetores)+2*j+1+2*i*ldv)=0; 
      }
      *((double*)zstk(Autovalores)+2*i)=d[i];
      *((double*)zstk(Autovalores)+2*i+1)=0;
   }

   free(d);
   free(bz);

   if(toupper(Modo[1])!='1')
   {
      free(Wi);free(Wz);
   }
}

/////////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////////

//LIMPANDO...
 //  printf(" LIMPANDO... \n");
   //if((Modo[1]=='3' & Rhs == 5) || Modo[1]=='1') free(sigma);
   
//   if(Rhs==4 || Rhs==5 && TemB) free(sigma); //sigma so sera alocado quando soh tiver 4 argumentos ou o quinto argumento for a matriz B.
   free(sigma);
   free(v);free(vector);
   free(ipiv); free(select);  //int
   free(workd);free(resid);free(workev);free(workl);//complex ou real

   LhsVar(1)= numd;
   if(Lhs==2) LhsVar(2)= numv;

   return 0;
}




void multf(int *Ap,int *Ai,double *Ar,double *Az,double *B,double *x,int ordem,int divisor)
{

  int coluna,linha,i;
  double *xtemp;

  xtemp = (double *) malloc (2*ordem*sizeof(double));
  for(i=0;i<2*ordem;i++)
     xtemp[i]=0;

  for(coluna=0;coluna<ordem;coluna++)/*conta normal: col 1,2,3... nao 0,1,2... */
  {
     for(i=Ap[coluna];i<Ap[coluna+1];i++)
     {
        linha=Ai[i];
        xtemp[2*linha]=xtemp[2*linha]+Ar[i]*B[2*coluna]-Az[i]*B[2*coluna+1];
        xtemp[2*linha+1]=xtemp[2*linha+1]+Ar[i]*B[2*coluna+1]+Az[i]*B[2*coluna];
     }
  }
  for(i=0;i<2*ordem;i++)
  {
     x[i]=xtemp[i]/divisor;
  }
  free(xtemp);
  return;
}

void multfr(int *Ap,int *Ai,double *Ar,double *B,double *x,int ordem)
{

  int coluna,linha,i;
  double *xtemp;

  xtemp = (double *) malloc (ordem*sizeof(double));
  for(i=0;i<ordem;i++)
     xtemp[i]=0;

  for(coluna=0;coluna<ordem;coluna++)/*conta normal: col 1,2,3... nao 0,1,2... */
  {
     for(i=Ap[coluna];i<Ap[coluna+1];i++)
     {
        linha=Ai[i];
        xtemp[linha]=xtemp[linha]+Ar[i]*B[coluna];
     }
  }
  for(i=0;i<ordem;i++)
  {
     x[i]=xtemp[i];
  }
  free(xtemp);
  return;
}
static int direct_gateway(char *fname,void F(void)) { F();return 0;};
static GenericTable Tab[]={
  {(Myinterfun)sci_gateway,intseigen,"eigen"},
};
 
int C2F(libarpack)()
{
  Rhs = Max(0, Rhs);
  (*(Tab[Fin-1].f))(Tab[Fin-1].name,Tab[Fin-1].F);
  return 0;
}
